//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include <math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TeeComma"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TForm1::MoveSeriesTo(int ARow)
{
  Series1->X0 = StringGrid1->Cells[2][ARow].ToInt() - 10;
  Series1->Y0 = StringGrid1->Cells[3][ARow].ToInt() - 10;
  Series1->X1 = Series1->X0 + 20;
  Series1->Y1 = Series1->Y0 + 20;
}

unsigned int TForm1::StrToMilli(int ARow)
{
   return (StringGrid1->Cells[0][ARow].ToInt() * 60000)
     + (StringGrid1->Cells[1][ARow].ToInt() * 1000);
}

void TForm1::CalcDelta()
{
  if (StringGrid1->Row < StringGrid1->RowCount - 1) {
    double TotalSteps = (StrToMilli(StringGrid1->Row + 1) -
      StrToMilli(StringGrid1->Row)) / Timer1->Interval;
    DeltaX = floor(((StringGrid1->Cells[2][StringGrid1->Row + 1].ToInt() -
      StringGrid1->Cells[2][StringGrid1->Row].ToInt()) / TotalSteps) + .5);
    DeltaY = floor(((StringGrid1->Cells[3][StringGrid1->Row + 1].ToInt() -
      StringGrid1->Cells[3][StringGrid1->Row].ToInt()) / TotalSteps) + .5);
  }
}

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  DeltaRot = -1;
  Chart1->LeftAxis->SetMinMax(0, 200);
  Chart1->BottomAxis->SetMinMax(0, 200);
  Chart1->View3DOptions->Elevation = 350;
  Chart1->View3DOptions->Orthogonal = false;

  FillGrid();
  FillRedLine();
}
//---------------------------------------------------------------------------
void TForm1::FillGrid()
{
  StringGrid1->ColCount = 4;
  StringGrid1->RowCount = 6;
  StringGrid1->Cells[0][0] = "Minute";
  StringGrid1->Cells[1][0] = "Second";
  StringGrid1->Cells[2][0] = "X";
  StringGrid1->Cells[3][0] = "Y";
  StringGrid1->DefaultColWidth = 45;

  // Index, minute,sec, X, Y
  AddPath(1, 0,  0,  80, 100);
  AddPath(2, 0,  1, 181,  80);
  AddPath(3, 0,  4,  94, 143);
  AddPath(4, 0,  7,   8,  28);
  AddPath(5, 0, 12, 180,  18);

  MoveSeriesTo(1);
}

void TForm1::AddPath(int Index, int Minute, int Second, int X, int Y)
{
  StringGrid1->Cells[0][Index] = Minute;
  StringGrid1->Cells[1][Index] = Second;
  StringGrid1->Cells[2][Index] = X;
  StringGrid1->Cells[3][Index] = Y;
}

void TForm1::FillRedLine()
{
  Series2->XValues->Order = loNone;
  for (int i=1;i<StringGrid1->RowCount;i++)
    Series2->AddXY(StringGrid1->Cells[2][i].ToInt(),
      StringGrid1->Cells[3][i].ToInt(), "", clTeeColor);
}

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  StringGrid1->Row = 1;
  MoveSeriesTo(StringGrid1->Row);
  MilliStart = GetTickCount();
  Timer1->Enabled = true;
  Button1->Enabled = false;
  CalcDelta();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  Chart1->View3DOptions->Rotation =
    Chart1->View3DOptions->Rotation + DeltaRot;
  if (Chart1->View3DOptions->Rotation < 290 ||
      Chart1->View3DOptions->Rotation > 356)
    DeltaRot = -DeltaRot;
  double Secs = (GetTickCount() - MilliStart) / 1000.0;
  Label3->Caption = "00:" + FormatFloat("00.0", Secs);
  Series1->X0 = Series1->X0 + DeltaX;
  Series1->Y0 = Series1->Y0 + DeltaY;
  Series1->X1 = Series1->X0 + 20;
  Series1->Y1 = Series1->Y0 + 20;
  if (StringGrid1->Row == StringGrid1->RowCount - 1) {
    Timer1->Enabled = false;
    Button1->Enabled = true;
  }
  else
    if ((GetTickCount() - MilliStart) > StrToMilli(StringGrid1->Row + 1)) {
    StringGrid1->Row++;
    CalcDelta();
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Series2GetMarkText(TChartSeries *Sender,
      int ValueIndex, AnsiString &MarkText)
{
  MarkText = String(floor(Sender->XValues->Value[ValueIndex] + .5)) + "," +
             String(floor(Sender->YValues->Value[ValueIndex] + .5));
}
//---------------------------------------------------------------------------

